truffe2/accounting_tools/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url


urlpatterns = patterns(
    'accounting_tools.views',

    url(r'^subvention/(?P<ypk>[0-9]+)/export$', 'export_demands_yearly'),
    url(r'^subvention/export_all$', 'export_all_demands'),

    url(r'^invoice/(?P<pk>[0-9]+)/pdf/', 'invoice_pdf'),
    url(r'^invoice/(?P<pk>[0-9]+)/bvr/', 'invoice_bvr'),

    url(r'^withdrawal/(?P<pk>[0-9]+)/pdf/', 'withdrawal_pdf'),
    url(r'^withdrawal/list/', 'withdrawal_available_list'),
    url(r'^withdrawal/(?P<pk>[0-9]+)/infos/', 'get_withdrawal_infos'),

    url(r'^internaltransfer/(?P<pk>[0-9,]+)/pdf/', 'internaltransfer_pdf'),
    url(r'^expenseclaim/(?P<pk>[0-9]+)/pdf/', 'expenseclaim_pdf'),
    url(r'^cashbook/(?P<pk>[0-9]+)/pdf/', 'cashbook_pdf'),
)

truffe2/app/urls.py
from django.conf.urls import patterns, include, url
from django.conf import settings

urlpatterns = patterns('',
    url(r'', include('main.urls')),
    url(r'^accounting/core/', include('accounting_core.urls')),
    url(r'^accounting/tools/', include('accounting_tools.urls')),
    url(r'^accounting/main/', include('accounting_main.urls')),
    url(r'^users/', include('users.urls')),
    url(r'^members/', include('members.urls')),
    url(r'^units/', include('units.urls')),
    url(r'^communication/', include('communication.urls')),
    url(r'^notifications/', include('notifications.urls')),
    url(r'^logistics/', include('logistics.urls')),
    url(r'^vehicles/', include('vehicles.urls')),
    url(r'^generic/', include('generic.urls')),

    url(r'^impersonate/', include('impersonate.urls')),

    (r'^' + settings.MEDIA_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),  # In prod, use apache !
    (r'^' + settings.STATIC_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),  # In prod, use apache !
)

truffe2/accounting_tools/models.py
# -*- coding: utf-8 -*-

from django import forms
from django.db import models
from django.utils.translation import ugettext_lazy as _
from django.contrib import messages
from django.contrib.contenttypes import generic
from django.contrib.contenttypes.models import ContentType
from django.conf import settings
from django.template.defaultfilters import date as _date
from django.utils import translation
from django.utils.timezone import now
from raven.contrib.django.models import client
from django.contrib.humanize.templatetags.humanize import intcomma
from django.template.defaultfilters import floatformat


import datetime
import string
from PIL import Image, ImageDraw, ImageFont
import os


from accounting_core.models import AccountingGroupModels
from accounting_core.utils import AccountingYearLinked, CostCenterLinked
from app.utils import get_current_year, get_current_unit
from generic.models import GenericModel, GenericStateModel, FalseFK, GenericContactableModel, GenericGroupsModel, GenericExternalUnitAllowed, GenericModelWithLines, ModelUsedAsLine, GenericModelWithFiles, GenericTaggableObject, GenericAccountingStateModel, LinkedInfoModel, SearchableModel
from notifications.utils import notify_people, unotify_people
from rights.utils import UnitExternalEditableModel, UnitEditableModel, AgepolyEditableModel


class _Subvention(GenericModel, GenericModelWithFiles, GenericModelWithLines, AccountingYearLinked, GenericStateModel, GenericGroupsModel, UnitExternalEditableModel, GenericExternalUnitAllowed, GenericContactableModel, SearchableModel):

    SUBVENTION_TYPE = (
        ('subvention', _(u'Subvention')),
        ('sponsorship', _(u'Sponsoring')),
    )

    class MetaRightsUnit(UnitExternalEditableModel.MetaRightsUnit):
        access = 'TRESORERIE'
        world_ro_access = False

    name = models.CharField(_(u'Nom du projet'), max_length=255)
    amount_asked = models.IntegerField(_(u'Montant demandé'))
    amount_given = models.IntegerField(_(u'Montant attribué'), blank=True, null=True)
    mobility_asked = models.IntegerField(_(u'Montant mobilité demandé'), blank=True, null=True)
    mobility_given = models.IntegerField(_(u'Montant mobilité attribué'), blank=True, null=True)
    description = models.TextField(_('Description'), blank=True, null=True)
    comment_root = models.TextField(_('Commentaire AGEPoly'), blank=True, null=True)
    kind = models.CharField(_(u'Type de soutien'), max_length=15, choices=SUBVENTION_TYPE, blank=True, null=True)
    linked_budget = FalseFK('accounting_main.models.Budget', verbose_name=_(u'Budget annuel lié'), blank=True, null=True)

    class Meta:
        abstract = True
        # unique_together = (("unit", "unit_blank_name", "accounting_year"),)

    class MetaEdit:
        only_if = {
            'linked_budget': lambda (obj, user): obj.unit,
        }

        files_title = _(u'Fichiers')
        files_help = _(u"""Envoie les fichiers nécessaires pour ta demande de subvention, les demandes incomplètes ne seront pas considérées.<br />
En cas de question, merci de contacter <a href="mailto:administration@agepoly.ch">administration@agepoly.ch</a>.<br /><br />
Vous devez inclure dans votre demande au moins :
<ul>
                       <li>Budget du projet. Un document complémentaire détaillant et expliquant le budget est vivement recommandé.</li>
    <li>Bilans et comptes des d'activité des années précédentes</li>
    <li>Documents officiels (pour les Association hors AGEPoly) : statuts, liste des membres du comité, PV de la dernière AG</li>
</ul>
Ces différents documents sont demandés au format PDF dans la mesure du possible, afin d'éviter les problèmes d'ouvertures et de mise en page.""")

    class MetaData:
        list_display = [
            ('name', _(u'Projet')),
            ('get_unit_name', _(u'Association / Commission')),
            ('amount_asked', _(u'Montant demandé')),
            ('mobility_asked', _(u'Mobilité demandé')),
            ('status', _(u'Statut')),
        ]

        default_sort = "[2, 'asc']"  # unit
        filter_fields = ('name', 'unit__name', 'unit_blank_name')

        details_display = list_display + [('description', _(u'Description')), ('accounting_year', _(u'Année comptable'))]
        details_display.insert(3, ('amount_given', _(u'Montant attribué')))
        details_display.insert(5, ('mobility_given', _(u'Montant mobilité attribué')))
        extra_right_display = {'comment_root': lambda (obj, user): obj.rights_can('LIST', user)}

        files_title = _(u'Fichiers')
        base_title = _(u'Subvention')
        list_title = _(u'Liste des demandes de subvention')
        base_icon = 'fa fa-list'
        elem_icon = 'fa fa-gift'

        menu_id = 'menu-compta-subventions'
        not_sortable_columns = ['get_unit_name']
        safe_fields = ['get_unit_name']

        has_unit = True

        forced_widths = {
            '3': '150px',
            '4': '150px',
        }

        help_list = _(u"""Les demandes de subvention peuvent être faites par toutes les commissions ou associations auprès de l'AGEPoly.""")

    class MetaAccounting:
        copiable = False

    class MetaLines:
        lines_objects = [
            {
                'title': _(u'Evènements'),
                'class': 'accounting_tools.models.SubventionLine',
                'form': 'accounting_tools.forms.SubventionLineForm',
                'related_name': 'events',
                'field': 'subvention',
                'sortable': True,
                'date_fields': ['start_date', 'end_date'],
                'show_list': [
                    ('name', _(u'Titre')),
                    ('start_date', _(u'Du')),
                    ('end_date', _(u'Au')),
                    ('place', _(u'Lieu')),
                    ('nb_spec', _(u'Nb personnes attendues')),
                ]
            },
        ]

    class MetaState:

        states = {
            '0_draft': _(u'Brouillon'),
            '0_correct': _(u'A corriger'),
            '1_submited': _(u'Demande soumise'),
            '2_treated': _(u'Demande traitée'),
        }

        default = '0_draft'

        states_texts = {
            '0_draft': _(u'La demande est en cours de création et n\'est pas publique.'),
            '1_submited': _(u'La demande a été soumise.'),
            '0_correct': _(u'La demande doit être corrigée.'),
            '2_treated': _(u'La demande a été traitée.'),
        }

        states_links = {
            '0_draft': ['1_submited'],
            '0_correct': ['1_submited'],
            '1_submited': ['2_treated', '0_correct'],
            '2_treated': [],
        }

        states_colors = {
            '0_draft': 'primary',
            '1_submited': 'default',
            '0_correct': 'warning',
            '2_treated': 'success',
        }

        states_icons = {
            '0_draft': '',
            '1_submited': '',
            '0_correct': '',
            '2_treated': '',
        }

        list_quick_switch = {
            '0_draft': [('1_submited', 'fa fa-check', _(u'Soumettre la demande'))],
            '0_correct': [('1_submited', 'fa fa-check', _(u'Soumettre la demande'))],
            '1_submited': [('2_treated', 'fa fa-check', _(u'Marquer la demande comme traitée')), ('0_correct', 'fa fa-exclamation', _(u'Demander des corrections'))],
            '2_treated': [],
        }

        forced_pos = {
            '0_draft': (0.2, 0.15),
            '0_correct': (0.5, 0.85),
            '1_submited': (0.5, 0.15),
            '2_treated': (0.8, 0.15),
        }

        states_default_filter = '0_draft,0_correct'
        status_col_id = 5

        class SubventionValidationForm(forms.Form):
            amount_given = forms.IntegerField(label=_(u'Montant accordé'))
            mobility_given = forms.IntegerField(label=_(u'Montant mobilité accordé'))

        states_bonus_form = {
            '2_treated': SubventionValidationForm
        }

    class MetaSearch(SearchableModel.MetaSearch):

        extra_text = u""

        index_files = True

        fields = [
            'name',
            'description',
            'comment_root',
            'amount_asked',
            'amount_given',
            'mobility_asked',
            'mobility_given',
        ]

        linked_lines = {
            'events': ['name', 'place']
        }

    def __init__(self, *args, **kwargs):
        super(_Subvention, self).__init__(*args, **kwargs)

        self.MetaRights = type("MetaRights", (self.MetaRights,), {})
        self.MetaRights.rights_update({
            'EXPORT': _(u'Peut exporter les éléments'),
        })

    def switch_status_signal(self, request, old_status, dest_status):

        s = super(_Subvention, self)

        if hasattr(s, 'switch_status_signal'):
            s.switch_status_signal(request, old_status, dest_status)

        if dest_status == '2_treated':
            self.amount_given = request.POST.get('amount_given', self.amount_given)
            self.mobility_given = request.POST.get('mobility_given', self.mobility_given)
            self.save()

    def may_switch_to(self, user, dest_state):
        return self.rights_can('EDIT', user) and super(_Subvention, self).may_switch_to(user, dest_state)

    def can_switch_to(self, user, dest_state):

        if self.status == '0_draft' and self.accounting_year.subvention_deadline and self.accounting_year.subvention_deadline < now() and not self.rights_in_root_unit(user, self.MetaRightsUnit.access):
            return (False, _(u'Le délait est dépassé pour les subventions !'))

        if self.status == '2_treated' and not user.is_superuser:
            return (False, _(u'Seul un super utilisateur peut sortir cet élément de l\'état traité'))

        if int(dest_state[0]) - int(self.status[0]) != 1 and not user.is_superuser:
            if not (self.status == '1_submited' and dest_state == '0_correct'):  # Exception faite de la correction

truffe2/accounting_tools/forms.py
# -*- coding: utf-8 -*-

from django.forms import ModelForm, DateInput
from django.utils.translation import ugettext_lazy as _

from accounting_tools.models import InvoiceLine, SubventionLine


class InvoiceLineForm(ModelForm):

    class Meta:
        model = InvoiceLine
        exclude = ('invoice', 'order',)


class SubventionLineForm(ModelForm):

    class Meta:
        model = SubventionLine
        exclude = ('subvention', 'order')

        widgets = {
            'start_date': DateInput(attrs={'class': 'datepicker'}),
            'end_date': DateInput(format='%Y-%m-%d', attrs={'class': 'datepicker'}),
        }

truffe2/accounting_tools/templates/accounting_tools/cashbook/edit.html
{% extends "accounting_tools/generic_tva_edit.html" %}
{% load i18n %}

{% block bonus_unit_updated %}
    update_users(pk);
    update_rcashs();
{% endblock %}

{% block bonus_year_updated %}
    update_accounts();
    update_rcashs();
{% endblock %}

{% block line_add_line_bonus %}
    {{block.super}}
    // Update accounts for the new line
    update_accounts();

    // Auto fill for the new helper + update_total
    new_line.find('.line_field_lines_helper select').change(function(e) {
        helper_autofill(e);
        update_total();
    });

    // Update total if value or value_ttc changes
    new_line.find('.line_field_lines_value_ttc input').change(function(e) {
        update_total();
    });

    new_line.find('.line_field_lines_value input').change(function(e) {
        update_total();
    });
{% endblock %}

{% block line_remove_line_bonus %}
    update_total();
{% endblock %}


{% block line_js_bonus %}
    {{block.super}}

    var credit_suisse_id = null;

    $(function () {
        // Remove style constraint on form max width
        $('.row').children().css('max-width', '');

        // Resize columns in the line table
        sizes = ['100px', '200px', '', '', '150px', '120px', '', '120px', ''];
        $("#lines_new_form_lines").children("td").each(function(index, element) {
            $(element).css('width', sizes[index]);
            if ($(element).find('select').length > 0)
                $(element).css('max-width', sizes[index]);
        });

        // Move costcenter and withdrawal up
        var costcenter = $('#id_costcenter').parents('.form-group').remove();
        $('#id_name').parents('.form-group').after(costcenter);

        var withdrawal = $('#id_withdrawal').parents('.form-group').remove();
        $('#id_name').parents('.form-group').after(withdrawal);

        // Transform id_user and id_withdrawal in select2
        $('#id_user').removeClass('form-control');
        $('#id_user').css('width', '100%').select2();

        $('#id_withdrawal').removeClass('form-control');
        $('#id_withdrawal').css('width', '100%').select2();

        // Enable/disable select2 if rcash chosen
        $('#s2id_id_withdrawal').next('select').change(function(e) {
            if (e.val != "") {
                $.ajax('{% url 'accounting_tools.views.get_withdrawal_infos' 99942999 %}'.replace(99942999, e.val)).done(function(data) {

                    $('#id_user').select2('val', data['user_pk']);
                    $('#id_user').attr('disabled', true);

                    $('#id_costcenter').select2('val', data['costcenter_pk']);
                    $('#id_costcenter').attr('disabled', true);

                    // Auto fill a line with withdrawal infos
                    $('#new_line').click();
                    new_line = $('#lines_tbody_lines tr:last');
                    new_line.find('.line_field_lines_date input').datepicker('setDate', data['date']);
                    new_line.find('.line_field_lines_helper select').select2('val', '0_withdraw');
                    new_line.find('.line_field_lines_label input').val('Retrait Cash');
                    new_line.find('.line_field_lines_account select').select2('val', credit_suisse_id);
                    new_line.find('.line_field_lines_tva input').select2('val', 0);
                });



            } else {
                $('select#id_user').attr('disabled', false);
                $('select#id_costcenter').attr('disabled', false);
            }
        });
        update_users({{CURRENT_UNIT_PK}});
        update_rcashs();
        update_accounts();
        update_total();

        // Disable fields if rcash selected on load
        if ($('#id_withdrawal').val() != '') {
            $('#id_user').attr('disabled', true);
            $('#id_costcenter').attr('disabled', true);
        }

        // Required to post values
        $('#generic_main_form').on('submit', function() {
            $('#id_user').attr('disabled', false);
            $('#id_costcenter').attr('disabled', false);
        });

        // Auto fill wrt helpers + update_total
        $('.line_field_lines_helper select').change(function(e) {
            helper_autofill(e);
            update_total();
        });

        $('.line_field_lines_value_ttc').change(function(e) {
            update_total();
        });

        $('.line_field_lines_value').change(function(e) {
            update_total();
        });

    });

    function update_users(pk) {
        $.ajax('{% url 'accounting_core.views.users_available_list_by_unit' 99942999 %}'.replace(99942999, pk)).done(function (data) {

            var old_value = $('#id_user').val();
            var options = '<option value=""></option>';

            $.each(data, function (index, option) {
                options += '<option value="' + option.pk + '">' + escape_html(option.name) + '</option>';
            });

            $('#id_user').select2('destroy');
            $('#id_user').html(options);
            $('#id_user').val(old_value);
            $('#id_user').select2();
        });
    }

    function update_rcashs() {
        $.ajax('{% url 'accounting_tools.views.withdrawal_available_list' %}?ypk=' + $('#input_ypk').val() + '&upk=' + $('#input_upk').val()).done(function (data) {
            var old_value = $('#id_withdrawal').val();
            var options = '<option value="">-------------</option>';

            $.each(data.data, function (index, option) {
                options += '<option value="' + option.pk + '">' + escape_html(option.name) + '</option>';
            });

            $('#id_withdrawal').select2('destroy');
            $('#id_withdrawal').html(options);
            $('#id_withdrawal').val(old_value);
            $('#id_withdrawal').select2();
        });
    }

    function update_accounts() {
        $.ajax('{% url 'accounting_core.views.account_available_list' %}?ypk=' + $('#input_ypk').val()).done(function (data) {

            var options = '<option value="">----------</option>';
            $.each(data.data, function (index, option) {
                options += '<option value="' + option.pk + '">' + escape_html(option.name) + '</option>';
                if (option.name.indexOf("{{CS_account_number}}") == 0)
                    credit_suisse_id = option.pk;
            });

            $('.line_field_lines_account .select2').each(function(index, element) {
                var elem = $(element).next('select');
                var old_value = elem.val();

                elem.select2('destroy');
                elem.html(options);
                elem.val(old_value);
                elem.select2();
            });
        });
    }

    function helper_autofill(e) {

        var row = $(e.target).parents('tr');
        var index = e.val[0];
        if (index == 0) {
            row.find('.line_field_lines_label input').val('Retrait Cash');
            row.find('.line_field_lines_proof input').val('');
            row.find('.line_field_lines_account select').select2('val', credit_suisse_id);
            row.find('.line_field_lines_tva input').select2('val', 0);
        } else if (index == 1) {
            row.find('.line_field_lines_label input').val('Versement Crédit Suisse');
            row.find('.line_field_lines_proof input').val('Crédit Suisse');
            row.find('.line_field_lines_account select').select2('val', credit_suisse_id);
            row.find('.line_field_lines_tva input').select2('val', 0);
        } else {
            {# row.find('.line_field_lines_label input').val(''); #}
            {# row.find('.line_field_lines_proof input').val(''); #}
            {# row.find('.line_field_lines_account select').select2('val', ''); #}
            {# row.find('.line_field_lines_tva input').select2('val', ''); #}
        }
    }

    function update_total() {
        var total = 0.0;

        $('#lines_tbody_lines tr').each(function(index, element) {
            var type = parseInt($(element).find('.line_field_lines_helper select').val()[0]);
            var amount = parseFloat($(element).find('.line_field_lines_value_ttc input').val());

            if (!isNaN(type) && !isNaN(amount)) {
                if (type == 0 || type == 2 || type == 6) {
                    total = total + amount;
                } else {
                    total = total - amount;
                }
            }
        });

        total = Math.round(total * 100) / 100;

        if (total < 0) {
            color = 'orange';
            remark = "{% trans "En l'état, l'AGEPoly devra rembourser ce montant à l'utilisateur responsable." %}";
        } else if (total > 0) {
            color = 'red';
            remark = "{% trans "Cet argent devra être remboursé par l'utilisateur responsable." %}";
        } else {
            color = 'green';
            remark = "{% trans "C'est bien !" %}";
        }
        $('#lines_footer span').css('color', color)
            .html("{% trans "Le total de ton journal de caisse fait" %} <b>" + total + " CHF</b>. " + remark);
    }

{% endblock %}

truffe2/accounting_tools/templates/accounting_tools/cashbook/list_json.html
{% extends "generic/generic/list_json.html" %}
{% load i18n %}

{% block bonus_buttons %}
    <a href=\"{% url 'accounting_tools.views.cashbook_pdf' elem.pk %}{% trans "Journal de Caisse" %} - {{elem.name|urlencode}}.pdf?{% if upk_noswitch %}&_upkns=_{% endif %}{% if from_related %}&_fromrelated=_{% endif %}\" style=\"margin-left: 3px;\" class=\"btn btn-xs btn-primary\" target=\"_blank\" title=\"{% trans "PDF" %}\" rel=\"tooltip\"><i class=\"fa fa-download\"></i></a>
{% endblock %}

truffe2/accounting_tools/templates/accounting_tools/cashbook/pdf.html
{% extends "base_pdf.html" %}
{% load i18n humanize %}

{% block title %}
    <h1 style="text-align: center; font-size: 30px; margin-top:-150px;">{% trans "Journal de caisse" %}</h1>
{% endblock %}

{% block pre_linkedinfo %}
    <tr class="tr-info"><td class="td-label">{% trans "Titre du journal de caisse : " %}</td><td class="td-large">{{object.name}}</td></tr>
    {% if object.proving_object %}
        {% if object.content_type.model == "withdrawal" %}
        <tr class="tr-info"><td class="td-label"><i>{% trans "Nom du retrait cash lié : " %}</i></td><td class="td-large">{{object.proving_object.name}}</td></tr>
        <tr class="tr-info"><td class="td-label">{% trans "Date du retrait cash lié : "%}</td><td class="td-large">{{object.proving_object.withdrawn_date|date:"d/m/Y"}}</td></tr>
        {% else %}
            <tr class="tr-info"><td class="td-label">{% trans "Attention, objet lié inconnu : "%}</td><td class="td-large">{{object.proving_object}}</td></tr>
        {% endif %}
    {% endif %}
{% endblock %}

{% block detail_table %}

    <table>
        <tr>
            <td style="width: 10%;"><b>{% trans "Date" %}</b></td>
            <td style="width: 23%;"><b>{% trans "Concerne" %}</b></td>
            <td style="width: 17%;"><b>{% trans "Justificatif" %}</b></td>
            <td style="width: 29%;"><b>{% trans "Numéro de compte" %}</b></td>
            <td style="width: 7%; text-align: center;"><b>{% trans "TVA" %}</b></td>
            <td style="width: 7%; text-align: center;"><b>{% trans "Entrée" %}</b></td>
            <td style="width: 7%; text-align: center;"><b>{% trans "Sortie" %}</b></td>
            <td style="width: 7%; text-align: center;"><b>{% trans "Solde" %}</b></td>
        </tr>

        {% for line in object.get_lines %}
            <tr class="tr-line">
                <td valign="top">{{line.date|date:"d/m/Y"}}</td>
                <td valign="top">{{line.label}}</td>
                <td valign="top">{{line.proof}}</td>
                <td valign="top">{{line.account}}</td>
                <td valign="top" style="text-align: right;">{{line.tva|floatformat:"2"}}</td>
                <td valign="top" style="text-align: right;">{{line.input_amount|intcomma}}</td>
                <td valign="top" style="text-align: right;">{{line.output_amount|intcomma}}</td>
                <td valign="top" style="text-align: right;">{{line.sub_total|intcomma}}</td>
            </tr>
        {% endfor %}

        <tr style="padding-top: 4px; text-align: right;" valign="middle">
            <td colspan="5"></td>
            <td>{{object.total_incomes}}</td>
            <td>{{object.total_outcomes}}</td>
            <td></td>
        </tr>

        <tr><td colspan="7">&nbsp;</td></tr>

        {% if object.get_total > 0 %}
            <tr>
                <td colspan="6" class="td-large" style="color: red;"><b>{% trans "Solde dû : " %}</b></td>
                <td class="td-large" style="text-align: right;"><b>{{object.get_total|intcomma}}</b></td>
            </tr>
            <tr><td colspan="7">&nbsp;</td></tr>
        {% elif object.get_total < 0 %}
            <tr>
                <td colspan="6" class="td-large" style="color: red;"><b>{% trans "Solde en sa faveur : " %}</b></td>
                <td class="td-large" style="text-align: right;"><b>{{object.get_total|intcomma|slice:"1:"}}</b></td>
            </tr>
            <tr><td colspan="7">&nbsp;</td></tr>
        {% endif %}

         <tr>
            <td colspan="3">{% trans "Nombre de justificatifs : " %}</td>
            <td>{{object.nb_proofs}}</td>
            <td colspan="3"></td>
        </tr>
        <tr><td colspan="7">&nbsp;</td></tr>

        <tr>
            <td colspan="3"><b>{% trans "Visa de la personne : " %}</b></td>
            <td colspan="4" style="border-bottom: 1px black solid;"></td>
        </tr>
        <tr><td colspan="7">&nbsp;</td></tr><tr><td colspan="7">&nbsp;</td></tr>

        <tr>
            <td colspan="3"><b>{% trans "Visa president(e) AGEPoly : " %}</b></td>
            <td colspan="4" style="border-bottom: 1px black solid;"></td>
        </tr>
        <tr><td colspan="7">&nbsp;</td></tr><tr><td colspan="7">&nbsp;</td></tr>

        <tr>
            <td colspan="3"><b>{% trans "Visa administrateur(trice) AGEPoly : " %}</b></td>
            <td colspan="4" style="border-bottom: 1px black solid;"></td>
        </tr>
    </table>
{% endblock %}

truffe2/accounting_tools/templates/accounting_tools/cashbook/show.html
{% extends "generic/generic/show.html" %}
{% load i18n humanize %}

{% block bonus_buttons %}
    <a href="{% url 'accounting_tools.views.cashbook_pdf' obj.pk %}{% trans "Journal de caisse" %} {{obj.name|urlencode}}.pdf?{% if upk_noswitch %}&_upkns=_{% endif %}{% if from_related %}&_fromrelated=_{% endif %}" style="margin-left: 3px;" class="btn btn-primary" target="_blank"><i class="fa fa-download"></i> PDF</a>
{% endblock %}

{% block post_lines %}
    <span class="pull-right">
        {% trans "Total (HT) : " %} <b>{{obj.get_total_ht|floatformat:"2"|intcomma}} CHF</b><br />
        {% trans "Total (TTC) : " %} <b>{{obj.get_total|floatformat:"2"|intcomma}} CHF</b>
    </span>
{% endblock %}